Description

Alya batch job rows (batchrows) can get stuck in the inprog status indefinitely. This happens when a JobManager worker picks up a
job but doesn't have the processor function registered locally for the job's app+op. The current error handling logs the issue but
doesn't update the status, blocking the entire batch from completing.

Associated revisions

Revision 625¢1b73 - 30/04/2025 10:57 AM - Sachin Divekar

Prevent jobs from getting stuck in 'inprog' status due to missing processors #27147

Jobs in the Alya Jobs package would get stuck in the 'inprog' status when a worker
picked up a job row but didn't have the processor function registered for that
app and operation.

Changes:

Added custom error types (ProcessorNotFoundError, ConfigurationError) to better identify and handle missing processor scenarios
Implemented handleProcessingError function to categorize errors and apply appropriate handling strategies

Added SQL queries to batch.sql for batch-updating rows by app and app+op

Used sqlc-generated code for database operations instead of direct SQL queries

Fixed error implementation to properly handle error cases via errors.As

Included detailed error messages in the failed rows for easier debugging

Added unit and integration tests to verify error handling behavior

Refactoring:

¢ Extracted single iteration of the job processing loop into RunOnelteration
¢ Added context aware methods RunWithContext and RunOnelterationWithContext

History

#1 - 08/05/2025 07:17 PM - Sachin Divekar
- % Done changed from 0 to 100

- Status changed from New to In Progress

#2 - 08/05/2025 07:17 PM - Sachin Divekar

- Status changed from In Progress to Closed
